#include<bits/stdc++.h>
#include <unistd.h>

#define REP(i, n) for(int i = 0; i < n; i++)

using namespace std;

int rnd(int a, int b){
	return a + (rand() % (b-a+1));
}

// Generuje uniformne nahodnou podmnozinu {min_n, ..., max_n} velikosti size v O(size*log(size))
vector<int> generate_random_integer_set(int min_n, int max_n, int size){
	int n = max_n - min_n;
	assert(size <= n+1);

	map<int, int> hold;

	vector<int> res(size, 0);
	REP(i, size){
		int x = rnd(min_n, min_n+n);
		int t = x;
		if(hold.find(x) != hold.end())x = hold[x];
		int k = min_n+n;
		if(hold.find(k) != hold.end())k = hold[k];
		hold[t] = k;
		res[i] = x;
		n--;
	}
	return move(res);
}

vector<int> generate_set_with_large_answer(int max_n, int size, int largeness){
	assert(size>=largeness);
	vector<int> res;
	int badnum = (1<<(largeness+1))-1;
	REP(i, largeness){
		res.push_back(badnum - (1<<i));
	}

	vector<int> others = generate_random_integer_set(1, max_n>>(largeness+2), size-largeness);
	for(auto && x : others){
//		cerr << "x " << x <<endl;
		res.push_back(badnum + (x<<(largeness+1)));
		assert(badnum + (x<<(largeness+1)) <= max_n);
	}
	return move(res);
}


// http://www.concentric.net/~Ttwang/tech/inthash.htm
// Workaround kvuli seedu na srand - proces se spousti mnohokrat za sekundu
unsigned long mix(unsigned long a, unsigned long b, unsigned long c)
{
    a=a-b;  a=a-c;  a=a^(c >> 13);
    b=b-c;  b=b-a;  b=b^(a << 8);
    c=c-a;  c=c-b;  c=c^(b >> 13);
    a=a-b;  a=a-c;  a=a^(c >> 12);
    b=b-c;  b=b-a;  b=b^(a << 16);
    c=c-a;  c=c-b;  c=c^(b >> 5);
    a=a-b;  a=a-c;  a=a^(c >> 3);
    b=b-c;  b=b-a;  b=b^(a << 10);
    c=c-a;  c=c-b;  c=c^(b >> 15);
    return c;
}


int main(int argc, char ** argv){
	


	vector<string> args(argv+1, argv+argc);
	int max_n = stoi(args[0]);
	int size = stoi(args[1]);
	assert(size <= max_n);

	unsigned long seed1 = stoi(args[2]);
	unsigned long seed2 = stoi(args[3]);


	unsigned long seed = mix(seed1, 4742, seed2*size);
	cerr << seed << endl;
	srand(seed);

	char type = args[4][0];
	assert(type == 'r' || type == 'l');

	vector<int> a;
	if(type == 'r')
		a = generate_random_integer_set(1, max_n, size);
	if(type == 'l'){
		int largeness = stoi(args[5]);
		a = generate_set_with_large_answer(max_n, size, largeness);
	}

	cout << size << endl;
	for(int i = 0; i < size; i++){
		if(i > 0)cout << " ";
		cout << a[i];
	}
	cout << endl;
}